<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_global_settings.php                                ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	check_admin_security("site_settings");

	$message_types = 
		array( 
			array(1, "HTML"), array(0, "Plain Text")
		);

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_global_settings.html");

	$t->set_var("admin_global_settings_href", "admin_global_settings.php");
	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_layout_scheme_href", "admin_layout_scheme.php");

	$r = new VA_Record($table_prefix . "global_settings");

	// load data to listbox
	$countries = get_db_values("SELECT country_code,country_name FROM " . $table_prefix . "countries ORDER BY country_order ", array(array("", "")));
	$admin_templates_dir_values = get_db_values("SELECT layout_id,layout_name FROM " . $table_prefix . "layouts", "");
	$payment_systems_values = get_db_values("SELECT payment_id,payment_name FROM " . $table_prefix . "payment_systems", "");

	$records_per_page = 
		array( 
			array(5, 5), array(10, 10), array(15, 15),
			array(20, 20), array(25, 25), array(50, 50),
			array(75, 75), array(100, 100)
			);

	$controls = 
		array(			
			array("NONE", "None"),  
			array("LISTBOX", "ListBox"),
			array("TEXTBOX", "TextBox")
			);

	$currency_positions = 
		array(			
			array(0, "None"),  
			array(1, "Left"),
			array(2, "Right")
			);

	$yes_no = 
		array( 
			array(1, "Yes"), array(0, "No")
			);

	$basket_actions = 
		array( 
			array(0, "Remain on the same page"), 
			array(1, "Go to the Shopping Cart")
			);


	// set up parameters
	$r->add_textbox("site_url", TEXT);
	$r->add_textbox("admin_email", TEXT);
	$r->add_select("country_code", TEXT, $countries);
	$r->add_select("layout_id", INTEGER, $admin_templates_dir_values);

	$r->add_checkbox("change_quantity", INTEGER);
	$r->add_select("quantity_control", TEXT, $controls);
	$r->add_select("redirect_to_cart", TEXT, $basket_actions);

	$r->add_textbox("weight_measure", TEXT);
	$r->add_select("payment_id", INTEGER, $payment_systems_values);
	$r->add_textbox("currency_sign", TEXT);
	$r->add_select("currency_position", INTEGER, $currency_positions);

	$r->add_checkbox("reviews_availability", INTEGER);
	$r->add_radio("approve_review", INTEGER, $yes_no);
	$r->add_select("reviews_per_page", INTEGER, $records_per_page);
	$r->add_textbox("min_rating", FLOAT);
	$r->add_textbox("min_votes", INTEGER);

	$r->add_textbox("html_on_index", TEXT);
	$r->add_textbox("html_below_footer", TEXT);

	$r->get_form_values();

	$site_url = $r->get_value("site_url");
	if(strlen($site_url) && substr($site_url, strlen($site_url) - 1) != "/") {
		$site_url .= "/";
    $r->set_value("site_url", $site_url);
	}

	$operation = get_param("operation");
	$return_page = get_param("rp");
	if(!strlen($return_page)) $return_page = "admin.php";

	if(strlen($operation))
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}

		if(!strlen($r->errors))
		{
			$sql = "DELETE FROM " . $table_prefix . "global_settings WHERE setting_type='global'";
			$db->query($sql);
			foreach($r->parameters as $key => $value)
			{
				$sql  = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES (";
				$sql .= "'global', '" . $key . "'," . $db->tosql($value[CONTROL_VALUE], TEXT) . ")";
				$db->query($sql);
			}
			set_session("session_settings", "");
			session_unregister("session_settings");

			header("Location: " . $return_page);
			exit;
		}
	}
	else // get global settings
	{
		foreach($r->parameters as $key => $value)
		{
			$sql  = "SELECT setting_value FROM " . $table_prefix . "global_settings ";
			$sql .= "WHERE setting_type='global' AND setting_name='" . $key . "'";
			$r->set_value($key, get_db_value($sql));
		}
	}

	$r->set_parameters();
	$t->set_var("rp", htmlspecialchars($return_page));

	$layout_scheme = "";
	$active_layout_id = $settings["layout_id"];
	$sql = " SELECT layout_name FROM " . $table_prefix . "layouts WHERE layout_id=" . $db->tosql($active_layout_id, INTEGER);
	$db->query($sql);
	if($db->next_record()) {
		$layout_lc = strtolower($db->f("layout_name"));
		if ($dir = @opendir($root_folder_path . "styles")) 
		{
			$dir_values = array();
		  while($file = readdir($dir)) {
				if ( preg_match("/^" . $layout_lc . "\_/", $file) ) { 
					$dir_values[] = $file;
		    } 
		  }  
  		closedir($dir);
			if(sizeof($dir_values) > 1) {
				$layout_scheme = "<a href=\"#\" onCLick=\"window.location='admin_layout_scheme.php'; return false;\">Change Active Scheme</a>";
			}
		}
	}
	$t->set_var("layout_scheme", $layout_scheme);

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>