<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_privileges_edit.php                                ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	check_admin_security("admin_users");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_privileges_edit.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_privileges_href", "admin_privileges.php");
	$t->set_var("admin_privileges_edit_href", "admin_privileges_edit.php");

	$r = new VA_Record($table_prefix . "admin_privileges");

	$r->add_where("privilege_id", INTEGER);
	$r->change_property("privilege_id", USE_IN_INSERT, true);
	$r->add_textbox("privilege_name", TEXT, "Privilege Type");
	$r->change_property("privilege_name", REQUIRED, true);

	$rps = new VA_Record($table_prefix . "admin_privileges_settings", "aps");

	$rps->add_checkbox("site_settings", INTEGER);
	$rps->add_checkbox("products_categories", INTEGER);
	$rps->add_checkbox("sales_orders", INTEGER);
	$rps->add_checkbox("layouts", INTEGER);
	$rps->add_checkbox("web_pages", INTEGER);
	$rps->add_checkbox("payment_systems", INTEGER);
	$rps->add_checkbox("products_reviews", INTEGER);
	$rps->add_checkbox("forum", INTEGER);
	$rps->add_checkbox("faq", INTEGER);
	$rps->add_checkbox("news", INTEGER);
	$rps->add_checkbox("events", INTEGER);
	$rps->add_checkbox("support", INTEGER);
	$rps->add_checkbox("site_users", INTEGER);
	$rps->add_checkbox("admin_users", INTEGER);
	$rps->add_checkbox("static_tables", INTEGER);
	$rps->add_checkbox("import_export", INTEGER);

	$r->get_form_values();
	$rps->get_form_values();

	$operation = get_param("operation");
	$privilege_id = get_param("privilege_id");
	$return_page = get_param("rp");
	if(!strlen($return_page)) $return_page = "admin_privileges.php";

	if(strlen($operation))
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		else if($operation == "delete" && $privilege_id)
		{
			$r->delete_record();
			$db->query("DELETE FROM " . $table_prefix . "admin_privileges_settings WHERE privilege_id=" . $db->tosql($privilege_id, INTEGER));
			header("Location: " . $return_page);
			exit;
		}

		$is_valid = $r->validate();

		if($is_valid)
		{
			if(strlen($privilege_id)) {
				$r->update_record();
				$db->query("DELETE FROM " . $table_prefix . "admin_privileges_settings WHERE privilege_id=" . $db->tosql($privilege_id, INTEGER));
			} else {
				$sql = " SELECT MAX(privilege_id) FROM " . $table_prefix . "admin_privileges ";
				$privilege_id = get_db_value($sql) + 1;
				$r->set_value("privilege_id", $privilege_id);
				$r->insert_record();
			}

			foreach($rps->parameters as $key => $value)
			{
				$sql  = " INSERT INTO " . $table_prefix . "admin_privileges_settings (privilege_id, block_name, permission) VALUES (";
				$sql .= $db->tosql($privilege_id, INTEGER) . ", '" . $key . "'," . $db->tosql($value[CONTROL_VALUE], TEXT) . ")";
				$db->query($sql);
			}

			header("Location: " . $return_page);
			exit;
		}

	}
	else if(strlen($privilege_id))
	{
		$r->get_db_values();

		$sql  = " SELECT block_name,permission FROM " . $table_prefix . "admin_privileges_settings ";
		$sql .= " WHERE privilege_id=" . $db->tosql($privilege_id, INTEGER);
		$db->query($sql);
		while($db->next_record()) {
			$rps->set_value($db->f("block_name"), $db->f("permission"));
		}
	}

	$r->set_form_parameters();
	$rps->set_form_parameters();

	if(strlen($privilege_id))	
	{
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}
	else
	{
		$t->set_var("save_button", "Add New");
		$t->set_var("delete", "");	
	}

	$t->set_var("rp", htmlspecialchars($return_page));

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>