<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_product.php                                        ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/tree.php");

	check_admin_security("products_categories");

	$category_id = get_param("category_id");
	if(!strlen($category_id)) $category_id = "0";

	$content_types = 
		array( 
			array(1, "HTML"), array(0, "Plain Text")
		);

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_product.html");

	$t->set_var("admin_product_href", "admin_product.php");
	$t->set_var("admin_upload_href", "admin_upload.php");
	$t->set_var("admin_select_href", "admin_select.php");
	$t->set_var("admin_items_list_href", "admin_items_list.php");

	$currency_left = "";
	$currency_right = "";
	if($settings["currency_position"] == 1)
		$currency_left = $settings["currency_sign"];
	else if($settings["currency_position"] == 2)
		$currency_right = $settings["currency_sign"];
	$t->set_var("currency_left", $currency_left);
	$t->set_var("currency_right", $currency_right);

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "tree");
	$tree->show($category_id);

	$r = new VA_Record($table_prefix . "items");

	// set up html form parameters
	$r->add_where("item_id", INTEGER);
	$r->change_property("item_id", USE_IN_INSERT, true);
	$r->add_hidden("category_id", INTEGER);

	$item_types = get_db_values("SELECT * FROM " . $table_prefix . "item_types", array(array("", "")));
	$r->add_select("item_type_id", INTEGER, $item_types, "Product Type");
	$r->parameters["item_type_id"][REQUIRED] = true;
	$r->add_textbox("item_name", TEXT, "Product Name");
	$r->parameters["item_name"][REQUIRED] = true;
	$r->add_textbox("item_order", INTEGER, "Product Order");
	$r->parameters["item_order"][REQUIRED] = true;
	$manufacturers = get_db_values("SELECT * FROM " . $table_prefix . "manufacturers", array(array("", "None")));
	$r->add_select("manufacturer_id", INTEGER, $manufacturers);
	$r->add_textbox("manufacturer_code", TEXT);
	$r->add_textbox("features", TEXT);
	$r->add_textbox("short_description", TEXT);
	$r->add_radio("full_desc_type", INTEGER, $content_types);
	$r->add_textbox("full_description", TEXT);
	$r->add_checkbox("is_special_offer", INTEGER);
	$r->add_textbox("special_offer", TEXT);
	$r->add_textbox("small_image", TEXT);
	$r->add_textbox("big_image", TEXT);
	$r->add_textbox("price", NUMBER, "Price");
	$r->parameters["price"][REQUIRED] = true;
	$r->add_textbox("buying_price", NUMBER, "Buying Price");
	$r->add_textbox("weight", NUMBER);
	$r->add_textbox("stock_level", NUMBER);
	$r->add_checkbox("use_stock_level", INTEGER);
	$r->add_checkbox("hide_out_of_stock", INTEGER);
	$r->add_checkbox("downloadable", INTEGER);
	$r->add_textbox("download_period", INTEGER, "Download Period");
	$r->add_textbox("download_path", TEXT, "Path to Downloadable File");
	$r->add_textbox("sales_price", NUMBER);
	$r->add_textbox("discount_percent", NUMBER);
	$r->add_checkbox("is_sales", INTEGER);
	$r->add_checkbox("is_showing", INTEGER);
	$r->add_textbox("notes", TEXT);
	$r->add_textbox("buy_link", TEXT);
	$r->add_textbox("votes", INTEGER);
	$r->add_textbox("points", INTEGER);
	$r->add_hidden("default_properties", TEXT);

	$times = get_db_values("SELECT * FROM " . $table_prefix . "shipping_times", array(array("", "None")));
	$r->add_select("shipping_in_stock", INTEGER, $times);
	$r->add_select("shipping_out_stock", INTEGER, $times);

	$rules = get_db_values("SELECT * FROM " . $table_prefix . "shipping_rules", array(array("", "None")));
	$r->add_select("shipping_rule_id", INTEGER, $rules);

	$r->get_form_values();

	$item_id = get_param("item_id");
	$operation = get_param("operation");
	$return_page = "admin_items_list.php?category_id=" . $category_id;
	if($r->get_value("downloadable")) {
		$r->parameters["download_period"][REQUIRED] = true;
		$r->parameters["download_path"][REQUIRED] = true;		
	}

	if(strlen($operation))
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		else if($operation == "delete" && $item_id)
		{
			// tables with item_id: items_downloads, orders_items, releases, reviews
			$properties_ids = array();
			$sql = " SELECT property_id FROM " . $table_prefix ."items_properties WHERE item_id=" . $db->tosql($item_id, INTEGER);		

			$db->query($sql);
			while ($db->next_record()) {
				$properties_ids[] = $db->f("property_id");
			}
			for($pi = 0; $pi < sizeof($properties_ids); $pi++) {
				$db->query("DELETE FROM " . $table_prefix . "items_properties_values WHERE property_id=" . $db->tosql($properties_ids[$pi], INTEGER));		
			}
			$db->query("DELETE FROM " . $table_prefix . "items_properties WHERE item_id=" . $db->tosql($item_id, INTEGER));		
			$db->query("DELETE FROM " . $table_prefix . "items_categories WHERE item_id=" . $db->tosql($item_id, INTEGER));		
			$db->query("DELETE FROM " . $table_prefix . "items WHERE item_id=" . $db->tosql($item_id, INTEGER));		
			header("Location: " . $return_page);
			exit;
		}

		$is_valid = $r->validate();
		
		if($is_valid)
		{
			if(strlen($item_id))
			{
				$r->update_record();
			}
			else
			{
				$db->query("SELECT MAX(item_id) FROM " . $table_prefix . "items");
				$db->next_record();
				$item_id = $db->f(0) + 1;
				$r->set_value("item_id", $item_id);
				$r->insert_record();
				$sql  = " INSERT INTO " . $table_prefix . "items_categories (item_id,category_id) VALUES (";
				$sql .= $db->tosql($item_id, INTEGER) . ",";
				$sql .= $db->tosql($category_id, INTEGER) . ")";
				$db->query($sql);
				// set default properties if exists
				if($r->get_value("default_properties") > 0) {
					$return_page = "admin_properties_add.php?category_id=" . $category_id . "&item_id=" . urlencode($item_id);
					header("Location: " . $return_page);
					exit;
				}
			}
	
			header("Location: " . $return_page);
			exit;
		}
	}
	else if(strlen($item_id))
	{
		$r->get_db_values();
	}
	else // new record (set default values)
	{
		$sql  = " SELECT MAX(item_order) FROM " . $table_prefix . "items i, " . $table_prefix . "items_categories ic ";
		$sql .= " WHERE i.item_id=ic.item_id ";
		$sql .= " AND ic.category_id=" . $db->tosql($category_id, INTEGER);
		$item_order = get_db_value($sql);
		$item_order = ($item_order) ? ($item_order + 1) : 1;
		$r->set_value("item_order", $item_order);
		//$r->set_value("use_stock_level", 1);
		//$r->set_value("hide_out_of_stock", 1);
		$r->set_value("is_showing", 1);
		$r->set_value("full_desc_type", 0);
		$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "global_settings ";
		$sql .= " WHERE setting_type='default_property'";
		$db->query($sql);
		$db->next_record();
		$default_properties = $db->f(0);
		$r->set_value("default_properties", $default_properties);
	}

	$r->set_form_parameters();

	if(strlen($item_id))	
	{
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}
	else
	{
		$t->set_var("save_button", "Add Product");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>