<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_review.php                                         ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/date_functions.php");

	check_admin_security("products_reviews");

	$s = get_param("s");
	$s_a = get_param("s_a");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_review.html");

	$t->set_var("admin_review_href", "admin_review.php");

	$r = new VA_Record($table_prefix . "reviews");
	$r->return_page  = "admin_reviews.php";
	$r->return_page .= "?s=" . $s . "&s_a=" . $s_a;

	$yes_no = 
		array( 
			array(1, "Yes"), array(0, "No")
		);

	$ratings = 
		array( 
			array(0, "None"), array(1, 1), array(2, 2), array(3, 3), array(4, 4), array(5, 5)
		);

	$r->add_where("review_id", INTEGER);
	$r->add_textbox("item_id", INTEGER);
	$r->change_property("item_id", USE_IN_UPDATE, false);
	$r->add_textbox("date_added", DATETIME, "Review Date");
	$r->change_property("date_added", REQUIRED, true);
	$r->change_property("date_added", VALUE_MASK, $datetime_edit_format);
	$r->add_textbox("summary", TEXT);
	$r->add_textbox("comments", TEXT);
	$r->add_textbox("user_name", TEXT, "User Name");
	$r->change_property("user_name", REQUIRED, true);
	$r->add_textbox("remote_address", TEXT);
	$r->add_radio("recommended", INTEGER, $yes_no);
	$r->change_property("recommended", REQUIRED, true);
	$r->add_radio("approved", INTEGER, $yes_no);
	$r->add_radio("rating", INTEGER, $ratings);

	$r->get_form_values();

	$review_id = get_param("review_id");
	if(!strlen($review_id))	
	{
		header("Location: " . $r->return_page);
		exit;
	}

	$operation = get_param("operation");
	if(strlen($operation))
	{
		if($operation == "cancel")
		{
			header("Location: " . $r->return_page);
			exit;
		}
		else if($operation == "delete" && $review_id)
		{
			$db->query("DELETE FROM " . $table_prefix . "reviews WHERE review_id=" . $db->tosql($review_id, INTEGER));		

			update_rating();

			header("Location: " . $r->return_page);
			exit;
		}

		$is_valid = $r->validate();

		if($is_valid)
		{
			if(strlen($r->get_value("review_id")))
				$r->update_record();
			else
				$r->insert_record();

			update_rating();

			header("Location: " . $r->return_page);
			exit;
		}
	}
	else if(strlen($r->get_value("review_id")))
	{
		$r->get_db_values();
	}

	$r->set_parameters();

	$t->set_var("item_name", get_db_value("SELECT item_name FROM " . $table_prefix . "items WHERE item_id=" . $db->tosql($r->get_value("item_id"), INTEGER)));	

	$t->set_var("s", $s);
	$t->set_var("s_a", $s_a);

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->set_var("date_added_format", join("", $datetime_edit_format));
	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_reviews_href", "admin_reviews.php");
	$t->pparse("main");


	function update_rating()
	{
		global $db;
		global $table_prefix;

		$review_id = get_param("review_id");
		$sql = "SELECT item_id FROM " . $table_prefix . "reviews WHERE review_id=" . $db->tosql($review_id, INTEGER);		
		$item_id = get_db_value($sql);

		$sql = " SELECT COUNT(*) FROM " . $table_prefix . "reviews WHERE approved=1 AND rating <> 0 AND item_id=" . $db->tosql($item_id, INTEGER);
		$total_rating_votes = get_db_value($sql);

		$sql = " SELECT SUM(rating) FROM " . $table_prefix . "reviews WHERE approved=1 AND rating <> 0 AND item_id=" . $db->tosql($item_id, INTEGER);
		$total_rating_sum = get_db_value($sql);
		if(!strlen($total_rating_sum)) $total_rating_sum = 0;

		$average_rating = $total_rating_votes ? $total_rating_sum / $total_rating_votes : 0;

		$sql  = " UPDATE " . $table_prefix . "items ";
		$sql .= " SET votes=" . $total_rating_votes . ", points=" . $total_rating_sum . ", ";
		$sql .= " rating=" . $average_rating;
		$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
		$db->query($sql);
	}



?>