<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  block_reviews.php                                        ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/
                           

function reviews($block_name)
{
	global $t;
	global $db, $table_prefix;
	global $settings;
	global $page_settings;
	global $category_id;
	global $HTTP_GET_VARS;
	global $datetime_show_format;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$t->set_file("block_body", "block_reviews.html");
	$t->set_var("AVERAGE_RATING_MSG", AVERAGE_RATING_MSG);
	$t->set_var("ALL_REVIEWS_MSG", ALL_REVIEWS_MSG);
	$t->set_var("ONLY_POSITIVE_MSG", ONLY_POSITIVE_MSG);
	$t->set_var("ONLY_NEGATIVE_MSG", ONLY_NEGATIVE_MSG);
	$t->set_var("POSITIVE_REVIEWS_MSG", POSITIVE_REVIEWS_MSG);
	$t->set_var("NEGATIVE_REVIEWS_MSG", NEGATIVE_REVIEWS_MSG);

	$t->set_var("REVIEWS_MSG", REVIEWS_MSG);
	$t->set_var("NO_REVIEWS_MSG", NO_REVIEWS_MSG);
	$t->set_var("RECOMMEND_PRODUCT_MSG", RECOMMEND_PRODUCT_MSG);
	$t->set_var("RATE_IT_MSG", RATE_IT_MSG);
	$t->set_var("ONE_LINE_SUMMARY_MSG", ONE_LINE_SUMMARY_MSG);
	$t->set_var("DETAILED_COMMENT_MSG", DETAILED_COMMENT_MSG);
	$t->set_var("NAME_ALIAS_MSG", NAME_ALIAS_MSG);
	$t->set_var("SHOW_MSG", SHOW_MSG);
	$t->set_var("VOTES_MSG", VOTES_MSG);
	$t->set_var("FOUND_MSG", FOUND_MSG);
	$t->set_var("SUBMIT_REVIEW_MSG", SUBMIT_REVIEW_MSG);
	$t->set_var("RATE_IT_BUTTON", RATE_IT_BUTTON);



	$errors = "";
	$is_item = true;

	$approve_review   = $settings["approve_review"];
	$reviews_per_page = $settings["reviews_per_page"];

	$t->set_var("reviews_href", "reviews.php");
	$t->set_var("products_href", "products.php");
	$t->set_var("product_details_href", "product_details.php");
	$t->set_var("rnd", time());

	$category_id = get_param("category_id");
	if(!strlen($category_id)) { $category_id = 0; } 
	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "tree", TOP_CATEGORY_MSG);
	$tree->show($category_id);

	$item_id  = get_param("item_id");
	if(!strlen($item_id)) {
		$errors = "Missing <b>Item ID</b>.<br>";
	} else {
		$sql = " SELECT item_name FROM " . $table_prefix . "items WHERE is_showing=1 AND item_id = " . $db->tosql($item_id, INTEGER);
		$db->query($sql);
		if($db->next_record())
		{
			$item_name = $db->f("item_name");
			$t->set_var("item_name", $item_name);
			$t->set_var("product_name", $item_name);
			$t->set_var("product_title", $item_name);
		}
		else
		{
			$is_item = false;
			$errors = NO_PRODUCT_MSG;
			$t->set_var("item_name", "ERROR (NO SUCH ITEM)");
		}
	}

	$r = new VA_Record($table_prefix . "reviews");

	$recommended = 
		array( 
			array(1, YES_MSG), array(0, NO_MSG)
			);

	$rating = 
		array( 
			array(0, OPTIONAL_MSG), array(1, BAD_MSG), array(2, POOR_MSG), 
			array(3, AVERAGE_MSG), array(4, GOOD_MSG), array(5, EXCELLENT_MSG),
			);

	//17-Jul-2002 08:26:44 AM

	$r->add_textbox("item_id", INTEGER);
	$r->add_radio("recommended", INTEGER, $recommended);
	$r->add_textbox("approved", INTEGER);
	$r->add_select("rating", INTEGER, $rating);
	$r->add_textbox("summary", TEXT);
	$r->add_textbox("user_name", TEXT);
	$r->add_textbox("remote_address", TEXT);
	$r->add_textbox("date_added", DATETIME);
	$r->add_textbox("comments", TEXT);
	
	$recommended_class = "normal"; 
	$user_name_class = "normal"; 

	$action = get_param("action");
	$rnd = get_param("rnd");
	$filter = get_param("filter");
	$remote_address = getenv("REMOTE_ADDR");

	if($action && !strlen($errors))
	{
		$sql  = " SELECT review_id FROM " . $table_prefix . "reviews ";
		$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER) . " AND remote_address='" . $remote_address . "'";		
		$db->query($sql);

		if($db->next_record())
			$errors = ALREADY_REVIEW_MSG;
	}

	$session_rnd = get_session("session_rnd");
	if($action && !strlen($errors) && $rnd != $session_rnd)
	{
		set_session("session_rnd", $rnd);
		$is_errors = false;

		$r->get_form_values();
  
		if($r->is_empty("recommended")) {
			$recommended_class = "error"; $is_errors = true; 
		}
		if($r->is_empty("user_name")) {
			$user_name_class = "error"; $is_errors = true; 
		}
		if($is_errors) {
			$provide_info_message = str_replace("{button_name}", RATE_IT_BUTTON, PROVIDE_INFO_MSG);
			$errors .= $provide_info_message . "<br>";	
			set_session("session_rnd", "");
		}

		if(!strlen($errors))
		{
			$r->set_value("date_added", va_time());
			$r->set_value("remote_address", $remote_address);
			$approve = $approve_review ? 0 : 1;
			$r->set_value("approved", $approve);

			$r->insert_record();
			if($approve) {
				update_rating($item_id);
			}

			$r->empty_values();
		}
	}

	$sql = " SELECT COUNT(*) FROM " . $table_prefix . "reviews WHERE approved=1 AND rating <> 0 AND item_id=" . $db->tosql($item_id, INTEGER);
	$total_rating_votes = get_db_value($sql);

	$average_rating_float = 0;
	$total_rating_sum = 0;
	if($total_rating_votes)
	{
		$sql = " SELECT SUM(rating) FROM " . $table_prefix . "reviews WHERE approved=1 AND rating <> 0 AND item_id=" . $db->tosql($item_id, INTEGER);
		$total_rating_sum = get_db_value($sql);
		$average_rating_float = round($total_rating_sum / $total_rating_votes, 2);
	}

	$t->set_var("current_category_id", $category_id);
	$t->set_var("item_id", $item_id);
	$r->set_value("item_id", $item_id);

	if($is_item)
	{
		$n = new VA_Navigator($settings["templates_dir"], "navigator.html", "reviews.php");
		// count recommended reviews
		$sql = " SELECT COUNT(*) FROM " . $table_prefix . "reviews WHERE recommended=1 AND approved=1 AND item_id=" . $db->tosql($item_id, INTEGER);
		$commend = get_db_value($sql);

		// count discommend reviews
		$sql = " SELECT COUNT(*) FROM " . $table_prefix . "reviews WHERE recommended=0 AND approved=1 AND item_id=" . $db->tosql($item_id, INTEGER);
		$discommend = get_db_value($sql);

		$total_votes = $commend + $discommend;

		if(strlen($filter))
		{
			$t->parse("all_reviews_link", false);
			if($filter == 1)
			{
				$t->parse("positive_reviews", false);
				$t->parse("negative_reviews_link", false);
			}
			else
			{
				$t->parse("positive_reviews_link", false);
				$t->parse("negative_reviews", false);
			}
		}
		else
		{
			$t->parse("all_reviews", false);
			$t->parse("positive_reviews_link", false);
			$t->parse("negative_reviews_link", false);
		}
		
		if($total_votes)
		{
			// parse summary statistic
			$t->set_var("commend_percent", round($commend / $total_votes * 100, 0));
			$t->set_var("discommend_percent", round($discommend / $total_votes * 100, 0));
			$t->set_var("total_votes", $total_votes);

			$average_rating = round($average_rating_float, 0);
			$average_rating_image = $average_rating ? "rating_" . $average_rating . ".gif" : "not_rated.gif";
			$t->set_var("average_rating_image", $average_rating_image);
			$t->set_var("average_rating_alt", $average_rating_float);

			$t->parse("summary_statistic", false);

			$sql    = " SELECT COUNT(*) FROM " . $table_prefix . "reviews ";
			$where  = " WHERE (summary IS NOT NULL OR comments IS NOT NULL) ";
			$where .= " AND approved=1 AND item_id=" . $db->tosql($item_id, INTEGER);
			if(strlen($filter))
				$where .= " AND recommended=" . $db->tosql($filter, INTEGER);
		
			$total_records = get_db_value($sql . $where);
			$t->set_var("total_records", $total_records);
			

			$record_number = 0;
			$records_per_page = $reviews_per_page ? $reviews_per_page : 10;
			$pages_number = 5;
			$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);
  
			$sql = " SELECT * FROM " . $table_prefix . "reviews ";
			$order_by = " ORDER BY date_added DESC";  
			$db->RecordsPerPage = $records_per_page;
			$db->PageNumber = $page_number;
			$db->query($sql . $where . $order_by);
			if($db->next_record())
			{
				do 
				{
					$record_number++;
					if($record_number > 1)
						$t->parse("delimiter", false);
					else
						$t->set_var("delimiter", "");
      
					$recommended_image = $db->f("recommended") ? "commend.gif" : "discommend.gif";
					$t->set_var("recommended_image", $recommended_image);
					$rating = round($db->f("rating"), 0);
					$rating_image = $rating ? "rating_" . $rating . ".gif" : "not_rated.gif";
					$t->set_var("rating_image", $rating_image);
					$t->set_var("review_user_name", htmlspecialchars($db->f("user_name")));
					$date_added = $db->f("date_added", DATETIME);
					$date_added_string = va_date($datetime_show_format, $date_added);
					$t->set_var("review_date_added", $date_added_string);
					$t->set_var("review_summary", htmlspecialchars($db->f("summary")));
					$t->set_var("review_comments", nl2br(htmlspecialchars($db->f("comments"))));
      
					$t->parse("reviews", true);
				} while ($db->next_record());
				$t->parse("reviews_block", false);
			}
			else
				$t->parse("no_reviews", false);
		}
		else
		{
			$t->set_var("total_records", 0);
			$t->parse("no_reviews", false);
		}
	}

	$t->set_var("recommended_class", $recommended_class);
	$t->set_var("user_name_class", $user_name_class);
	$r->set_parameters();

	if(strlen($errors)) {
		$t->set_var("errors", $errors);
		$t->parse("errors_block", false);
	}

	if(!strlen($errors) && $action) {
		$t->parse("thanks_block", false);
	}


	$t->parse("block_body", false);
	$t->parse($block_name, true);

}

function update_rating($item_id)
{
	global $db, $table_prefix;
	
	$sql = " SELECT COUNT(*) FROM " . $table_prefix . "reviews WHERE approved=1 AND rating <> 0 AND item_id=" . $db->tosql($item_id, INTEGER);
	$total_rating_votes = get_db_value($sql);

	$sql = " SELECT SUM(rating) FROM " . $table_prefix . "reviews WHERE approved=1 AND rating <> 0 AND item_id=" . $db->tosql($item_id, INTEGER);
	$total_rating_sum = get_db_value($sql);
	if(!strlen($total_rating_sum)) $total_rating_sum = 0;

	$average_rating = $total_rating_votes ? $total_rating_sum / $total_rating_votes : 0;

	$sql  = " UPDATE " . $table_prefix . "items ";
	$sql .= " SET votes=" . $total_rating_votes . ", points=" . $total_rating_sum . ", ";
	$sql .= " rating=" . $average_rating;
	$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
	$db->query($sql);
}


?>