<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  block_top_products.php                                   ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


function top_products($block_name)
{
	global $t;
	global $db, $table_prefix;
	global $settings;
	global $category_id;
	global $page_settings;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$t->set_file("block_body", "block_top_products.html");
	$t->set_var("product_details_href", "product_details.php");
	$t->set_var("TOP_RATED_TITLE", TOP_RATED_TITLE);

	if(!isset($category_id)) $category_id = get_param("category_id");
	if(!strlen($category_id)) $category_id = "0";

	$sql  = " SELECT i.item_id, i.item_name, i.rating ";
	$sql .= " FROM " . $table_prefix . "items i, " . $table_prefix . "items_categories ic";
	if($category_id)
		$sql .= ", " . $table_prefix . "categories c ";
	$sql .= " WHERE i.item_id=ic.item_id ";
	if($category_id) {
		$top_tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "catalog_tree");
		$sql .= " AND c.category_id = ic.category_id ";
		$sql .= " AND (ic.category_id = " . $db->tosql($category_id, INTEGER);
		$sql .= " OR c.category_path LIKE '" . $db->tosql($top_tree->get_path($category_id), TEXT, false) . "%')";
	}
	$sql .= " AND i.is_showing=1 AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0)";
	$sql .= " AND i.votes>=" . $db->tosql(get_setting_value($settings, "min_votes", 10), INTEGER);
	$sql .= " AND i.rating>=" . $db->tosql(get_setting_value($settings, "min_rating", 1), FLOAT);
	$sql .= " GROUP BY i.item_id, i.item_name, i.rating, i.item_order ";
	$sql .= " ORDER BY i.rating DESC, i.item_order, i.item_name  ";

	$db->RecordsPerPage = 10;
	$db->PageNumber = 1;
	$db->query($sql);
	if($db->next_record())
	{
		$item_number = 0;
		do
		{
			$item_number++;
			$t->set_var("product_position", $item_number);
			$t->set_var("item_id", $db->f("item_id"));
			$t->set_var("category_id", $db->f("category_id"));
			$t->set_var("product_name", $db->f("item_name"));
			$t->set_var("rating", number_format($db->f("rating"), 2));

			$t->parse("rating_products");
		} while ($db->next_record());              	
		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}



}

?>