<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  order_links.php                                          ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	function send_order_links($order_id, $status_id = 0)
	{
	 	global $t;
		global $db;
		global $settings;
		global $table_prefix;
		global $datetime_show_format;

		if ($status_id) {
			$sql  = " UPDATE " . $table_prefix . "orders SET order_status=" . intval($status_id);
			$sql .= " WHERE order_id=" . intval($order_id);
			$db->query($sql);
		}
		
		$sql = "SELECT download_activation FROM " . $table_prefix . "order_statuses WHERE status_id=" . intval($status_id);
		$download_action = get_db_value($sql);
		if($download_action == 1) {
			$sql = "UPDATE " . $table_prefix . "items_downloads SET activated=1 WHERE order_id=" . intval($order_id);
			$db->query($sql);
		} else if($download_action == 0) {
			$sql = "UPDATE " . $table_prefix . "items_downloads SET activated=0 WHERE order_id=" . intval($order_id);
			$db->query($sql);
		}

		// check if we have downloadable product so we can send notification
		$sql = "SELECT COUNT(*) FROM " . $table_prefix . "items_downloads WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$links_number = get_db_value($sql);
		$downloadable_links = ($links_number > 0) ? 1 : 0;

		if(!$downloadable_links) {
			return;
		}

		$currency_left = ($settings["currency_position"] == 1) ? $settings["currency_sign"] : "";
		$currency_right = ($settings["currency_position"] == 2) ? $settings["currency_sign"] : "";
		$site_url = $settings["site_url"];

	  $t = new VA_Template($settings["templates_dir"]);
		$t->set_var("site_url", $site_url);

		// get default values for email message
		$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='order_final'";
		$db->query($sql);
		while($db->next_record()) {
			$order_final[$db->f("setting_name")] = $db->f("setting_value");
		}

		// prepare email headers
		$mail_from = get_setting_value($order_final, "links_from", $settings["admin_email"]);
		$mail_cc = get_setting_value($order_final, "links_cc");
		$mail_bcc = get_setting_value($order_final, "links_bcc");
		$mail_reply_to = get_setting_value($order_final, "links_reply_to");
		$mail_return_path = get_setting_value($order_final, "links_return_path");
		$mail_type = get_setting_value($order_final, "links_message_type");
		$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

	  // get customer email
		$sql = "SELECT delivery_email, email FROM " . $table_prefix . "orders WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if($db->next_record()) {
			$message_to = strlen($db->f("delivery_email")) ? $db->f("delivery_email") : $db->f("email");
		} 


		// preparing download links
		$links = "";
		$sql  = " SELECT id.download_id, id.download_added, id.download_path, ";
		$sql .= " oi.item_name, i.download_path AS product_path ";
		$sql .= " FROM ((" . $table_prefix . "items_downloads id ";
		$sql .= " INNER JOIN " . $table_prefix . "orders_items oi ON id.order_item_id=oi.order_item_id) ";
		$sql .= " LEFT JOIN " . $table_prefix . "items i ON id.item_id=i.item_id) ";
		$sql .= " WHERE id.order_item_id=oi.order_item_id ";
		$sql .= " AND id.order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if($db->next_record()) {
			$message_body = "";
			do {
				$item_name = $db->f("item_name");
				$product_path = trim($db->f("product_path"));
				$path_to_file = trim($db->f("download_path"));
				if (!$path_to_file) {
					$path_to_file = $product_path;
				} 
				$paths = split(";", $path_to_file);
				$download_path = $paths[0];
		    $file_size = @filesize ($download_path);
				$file_name = basename($download_path);
				if ($file_size > 1048576) {
					$file_name .= " (" . number_format($file_size / (1024 * 1024), 1) . " Mb)";
				} else if ($file_size > 1024) {
					$file_name .= " (" . number_format($file_size / 1024) . " Kb)";
				}	else if ($file_size) {
					$file_name .= " (" . number_format($file_size) . " bytes)";
				}

				$download_id = $db->f("download_id");
				$download_added = $db->f("download_added", DATETIME);
				$item_download_url  = $site_url . "download.php?download_id=" . $download_id;
				$vc = md5($download_id . $download_added[3].$download_added[4].$download_added[5]);
				$item_download_url .= "&vc=" . urlencode($vc);
				if($mail_type) {
					$links .= htmlspecialchars($item_name) . "<br>";
					$links .= "<a href=\"" . $item_download_url . "\">" . $file_name . "</a><br>";
				} else {
					$links .= $item_name . "\n";
					$links .= $file_name . "\n" . $item_download_url . "\n";
				}
			} while ($db->next_record());
		} 

		if(isset($order_final["links_subject"]) && $order_final["links_subject"]) {
			$links_subject = $order_final["links_subject"];
		} else {
			$links_subject = "Links For Your Order";
		}

		if(isset($order_final["links_message"]) && $order_final["links_message"]) {
			$links_message = $order_final["links_message"];
		} else {
			$links_message = $links;
		}

		$t->set_block("message_subject", $links_subject);
		$t->set_block("message_body", $links_message);

		$items_text = show_order_items($order_id, false);
		$t->set_var("basket", $items_text);
		$t->set_var("items", $items_text);
		$t->set_var("products", $items_text);
		$sql = "SELECT * FROM " . $table_prefix . "orders WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		$db->next_record();
		$state_code = $db->f("state_code");
		$country_code = $db->f("country_code");
		$delivery_state_code = $db->f("delivery_state_code");
		$delivery_country_code = $db->f("delivery_country_code");
		$cc_type = $db->f("cc_type");
		$order_placed_date = $db->f("order_placed_date", DATETIME);
		$goods_total = $db->f("goods_total");
		$shipping_cost = $db->f("shipping_cost");
		$tax_percent = $db->f("tax_percent");
		$order_total = round($goods_total, 2) + round($shipping_cost, 2);
		if($tax_percent > 0) {
			$tax_cost = ($order_total / 100) * $tax_percent;
			$tax_cost = round($tax_cost, 2);
			$order_total += $tax_cost;
			$t->set_var("tax_cost", $currency_left . number_format($tax_cost, 2) . $currency_right);
		}

		$t->set_vars($db->Record);
		$t->set_var("goods_total", $currency_left . number_format($goods_total, 2) . $currency_right);
		$t->set_var("shipping_cost", $currency_left . number_format($shipping_cost, 2) . $currency_right);
		$t->set_var("order_total", $currency_left . number_format($order_total, 2) . $currency_right);
		$t->set_var("tax_percent", number_format($db->f("tax_percent"), 2) . "%");

		$date_formated = va_date($datetime_show_format, $order_placed_date);
		$cc_start = va_date(array("MM", " / ", "YYYY"), $db->f("cc_start_date", DATETIME));
		$cc_expiry = va_date(array("MM", " / ", "YYYY"), $db->f("cc_expiry_date", DATETIME));

		$state = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($state_code, TEXT));
		$delivery_state = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($delivery_state_code, TEXT));
		$country = get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($country_code, TEXT));
		$delivery_country = get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($delivery_country_code, TEXT));
		$cc_type = get_db_value("SELECT credit_card_name FROM " . $table_prefix . "credit_cards WHERE credit_card_id=" . $db->tosql($cc_type, INTEGER));

		$t->set_var("order_placed_date", $date_formated);
		$t->set_var("order_placed", $date_formated);
		$t->set_var("links", $links);

		$t->set_var("state", $state);
		$t->set_var("country", $country);
		$t->set_var("delivery_state", $delivery_state);
		$t->set_var("delivery_country", $delivery_country);
		$t->set_var("cc_type", $cc_type);
		$t->set_var("cc_start_date", $cc_start);
		$t->set_var("cc_expiry_date", $cc_expiry);
	
		$t->parse("message_subject", false);
		$t->parse("message_body", false);

		$message_subject = $t->get_var("message_subject");
		$message_body = $t->get_var("message_body");
		$message_body = str_replace("\r", "", $message_body);

		mail($message_to, $message_subject, $message_body, $email_headers);

	}

?>