<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  payment.php                                              ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./includes/common.php");
	include("./includes/order_items.php");
	include("./includes/date_functions.php");
	include("./includes/parameters.php");
	include_once ("./messages/".$language_code."/cart_messages.php");

  $t = new VA_Template($settings["templates_dir"]);
  $t->set_file("main","payment.html");
  $t->set_var("CHECKOUT_PAYMENT_TITLE", CHECKOUT_PAYMENT_TITLE);
  $t->set_var("CONTINUE_BUTTON",        CONTINUE_BUTTON);

	$order_id = get_param("order_id");
	$order_errors = check_order();

	if($order_errors) {
		$t->set_var("errors_list", $order_errors);
		$t->parse("errors");
	} else {
		$variables = array();
		$cart_items = array();
		$total_items = 0;
		$items_text = show_order_items($order_id, false);
		$variables["order_id"] = $order_id;
		$variables["items"] = $items_text;
		$variables["basket"] = $items_text;
		$variables["description"] = $items_text;

		$sql = "SELECT * FROM " . $table_prefix . "orders WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if($db->next_record()) {
			for($i = 0; $i < sizeof($parameters); $i++) {
				$variables[$parameters[$i]] = $db->f($parameters[$i]);
				$variables["delivery_" . $parameters[$i]] = $db->f("delivery_" . $parameters[$i]);
			}
			$address = $variables["address2"] ? ($variables["address1"] . " " . $variables["address2"]) : $variables["address1"];
			$delivery_address = $variables["delivery_address2"] ? ($variables["delivery_address1"] . " " . $variables["delivery_address2"]) : $variables["delivery_address1"];
			$variables["address"] = $address;
			$variables["delivery_address"] = $delivery_address;

			$order_placed_date = $db->f("order_placed_date", DATETIME);
			$vc = md5($order_id . $order_placed_date[3].$order_placed_date[4].$order_placed_date[5]);

			$variables["vc"] = $vc;
			$variables["order_placed_date"] = va_date($datetime_show_format, $order_placed_date);

			$variables["user_id"] = $db->f("user_id");
			$variables["affiliate_code"] = $db->f("affiliate_code");
			$variables["goods_total"] = $db->f("goods_total");
			$variables["total_quantity"] = $db->f("total_quantity");
			$variables["total_items"] = $total_items;
			$variables["weight_total"] = $db->f("weight_total");
			$variables["total_weight"] = $db->f("weight_total");
			$variables["shipping_cost"] = $db->f("shipping_cost");
			$variables["total_discount"] = $db->f("total_discount");
			$variables["tax_name"] = $db->f("tax_name");
			$variables["tax_percent"] = $db->f("tax_percent");
			$variables["tax_cost"] = 0;
			$order_total = round($variables["goods_total"], 2) + round($variables["shipping_cost"], 2);
			if($variables["tax_percent"] > 0) {
				$tax_cost = ($order_total / 100) * $variables["tax_percent"];
				$tax_cost = round($tax_cost, 2);
				$order_total += $tax_cost;
				$variables["tax_cost"] = $tax_cost;
			}
			$variables["order_total"] = $order_total;
			$variables["state"] = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($variables["state_code"], TEXT));
			$variables["country"] = get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($variables["country_code"], TEXT));
			$variables["delivery_state"] = get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($variables["delivery_state_code"], TEXT));
			$variables["delivery_country"] = get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($variables["delivery_country_code"], TEXT));
		}

		$sql = "SELECT setting_value FROM " . $table_prefix . "global_settings WHERE setting_name='payment_id' AND setting_type='global'";
		$payment_id = get_db_value($sql);
		$db->query("SELECT * FROM " . $table_prefix . "payment_systems WHERE payment_id=" . $db->tosql($payment_id, INTEGER));
		$db->next_record();
		$payment_url = $db->f("payment_url");
		$submit_method = $db->f("submit_method");
		$payment_name = $db->f("payment_name");
		$t->set_var("payment_url", htmlspecialchars($payment_url));
		$t->set_var("payment_name", $payment_name);
		$t->set_var("submit_method", $submit_method);

		$goto_payment_message = str_replace("{payment_system}", $payment_name, GOTO_PAYMENT_MSG);
		$goto_payment_message = str_replace("{button_name}", CONTINUE_BUTTON, $goto_payment_message);
		$t->set_var("GOTO_PAYMENT_MSG", $goto_payment_message);

		$parameter_number = 0;
		$db->query("SELECT * FROM " . $table_prefix . "payment_parameters WHERE payment_id=" . $db->tosql($payment_id, INTEGER));
		while($db->next_record())
		{
			$parameter_source = $db->f("parameter_source");
			$parameter_name = $db->f("parameter_name");
			$parameter_type = $db->f("parameter_type");

			if (preg_match("/\{digit\}/", $parameter_name) || preg_match("/\{no_digit\}/", $parameter_name)) {
				for($i = 0; $i < sizeof($cart_items); $i++) {
					$parameter_number++;
					$cart_item = $cart_items[$i];
					$digit_parameter = str_replace("{digit}", ($i + 1), $parameter_name);
					$digit_parameter = str_replace("{no_digit}", "", $digit_parameter);
					$payment_url .= ($parameter_number == 1) ? "?" : "&";
					if($parameter_type == "CONSTANT") {
						$parameter_value = $parameter_source;
					} else if($parameter_type == "VARIABLE") {
						if(preg_match("/[\,\;\:\s]/", $parameter_source, $match)) {
							$separator = $match[0];
							$parameter_sources = split($separator, $parameter_source);
							$parameter_value = "";
							for($p = 0; $p < sizeof($parameter_sources); $p++) {
								if ($p != 0) { $parameter_value .= $separator; }
								$l_source = strtolower($parameter_sources[$p]);
								$parameter_value .= isset($cart_item[$l_source]) ? $cart_item[$l_source] : $parameter_sources[$p];
							}
						} else {
							$l_source = strtolower($parameter_source);
							$parameter_value = isset($cart_item[$l_source]) ? $cart_item[$l_source] : $parameter_source;
						}
					}
					$payment_url .= $digit_parameter . "=" . urlencode($parameter_value);
					$t->set_var("parameter_name", $digit_parameter);
					$t->set_var("parameter_value", htmlspecialchars($parameter_value));
					$t->parse("parameters", true);
				}
			} else {
				$parameter_number++;
				$payment_url .= ($parameter_number == 1) ? "?" : "&";
				if($parameter_type == "CONSTANT") {
					$parameter_value = $parameter_source;
				} else if($parameter_type == "VARIABLE") {
					if(preg_match("/[\,\;\:\s]/", $parameter_source, $match)) {
						$separator = $match[0];
						$parameter_sources = split($separator, $parameter_source);
						$parameter_value = "";
						for($p = 0; $p < sizeof($parameter_sources); $p++) {
							if ($p != 0) { $parameter_value .= $separator; }
							$l_source = strtolower($parameter_sources[$p]);
							$parameter_value .= isset($variables[$l_source]) ? $variables[$l_source] : $parameter_sources[$p];
						}
					} else {
						$l_source = strtolower($parameter_source);
						$parameter_value = isset($variables[$l_source]) ? $variables[$l_source] : $parameter_source;
					}
				}
				$payment_url .= $parameter_name . "=" . urlencode($parameter_value);
				$t->set_var("parameter_name", $parameter_name);
				$t->set_var("parameter_value", htmlspecialchars($parameter_value));
				$t->parse("parameters", true);

			}
		}
		if($submit_method == "GET") {
			header("Location: " . $payment_url);
			exit;
		}
	}

	$t->pparse("main");

?>
